 /*
  * hashblist.h 
  */
  
/* ip addr is key */
struct bnode {
	unsigned int netmask;		/* in host byte order */
	unsigned short port;		
	unsigned short wildcard;	/* true if all ports (any) */
	char *tag;			/* pointer to tag in stringlist */
};

#define HSIZE 104729

#include "stringstore.h"

struct blist{
	struct stringlist sl;		/* used for storage of event log messages */
	struct stringlist sltags;	/* used for storage of tag messages */
	unsigned int entries;
	unsigned int pktcount;		/* max packets to store in dump file */
	unsigned int count;             /* stateful counter */
	pcap_dumper_t *pcapfd;
	int match;			/* need an elog message */
};

extern int blist_config;

/**************************************************/
/* function prototypes */

void
config_blist_dumpfile(char *, unsigned int);

/* insert entries into the hash list
*/
void
config_blist(char *tag, char *filename);

void
search_blist(struct pcap_pkthdr *, u_char *, struct t_entry *te);

/* the blist may issue a probe event to alert the admin
 * that there is data in the autocapture dump
 */
void 
print_blist(FILE *mon);


