#! /usr/bin/perl 

#
# cctodns.pl
#
# syntax:
#
#       cctodns.pl
#
#       inputfile - REN-ISAC list of DNS names
#       outputfile - an ourmon dns blacklist of dns names
#		syntax: dnsname type (type can only be A, AAAA, CNAME, or MX)
#	note: we are not checking for type errors here.

use strict;
use Getopt::Std;

our $input = "/home/mrourmon/etc/dns.orig.txt";
our %dnsdb;

doit($input);

exit(0);

#
# doit
# parse input file
#
sub doit() {

        my $inputfile = shift;
        my $curline;
        my @words;

        #my $basename = File::Basename::basename($inputfile);
        #my @PARTS = split(/\./, $basename);

        open(FILE, $inputfile) || die "can't open $inputfile: $!\n";

        my $linecount = 0;
        while(<FILE>) {

                $linecount++;
                s/\n//g;
#               s/ //g;
                s/\t//g;
                my $curline = $_;
                # note the escape needed
                #@words = split(/\|/, $curline);
                @words = split(" ", $curline);
#if( $words[0] =~ /^#.*/){
#       print "true\n";
#}
#else {
#       print "false\n";
#}
                if ($linecount < 3) {
                        next;
                }
                elsif( $words[0] =~ /^#/){
                        next;
                }
                elsif( $words[0] =~ /<\/p.*/){ # what is this for?
                        next;
                }
#print "$words[0], $words[1], $words[2]\n";
#print "$words[0]\n";

                my $dnsname = $words[0];
#print "$words[0], $words[1], $words[2]\n";
#print "$words[0]\n";

		my $type = $words[2];

                iptodns($dnsname, $type);

        }  # end loop
        close(FILE);
}

sub
iptodns
{
        my $dnsname = lc $_[0];
        my $type = $_[1];

	# suppress duplicates
        if ($dnsdb{$dnsname}) {
                $dnsdb{$dnsname}++;
        }
        else {
                $dnsdb{$dnsname} = 1;
		print "$dnsname $type\n";
        }
}
