#! /usr/bin/perl

#
# ccip.pl - extract IPs and port number from ren-isac IP blacklist
# 	and put them in output file as 2-tuple
#
# syntax:
#
#	ccip  inputfile  > stdout
#
#	inputfile - REN-ISAC list of cc IP addresses
#	stdout - list of IP addresses plus ports only
#
# error handling: 
#	lines with invalid port numbers are ignored
#	TODO: should add check to make sure IP address
#	is IP address.  should handle IPv6?
#

use Socket;
use Getopt::Std;
use File::Basename();
#use Time::Local;
# comment in for ctime, note that it overrides localtime
#use Time::localtime;

$debug = 0;
$argc=$#ARGV+1;

if ($argc != 1) {
	print "syntax: # ccip.pl imputfile\n";
	print "example: # ccip.pl /home/mrourmon/etc/foo.txt\n";
	exit(1);
}

my $input = $ARGV[0];

#%options=();
#getopts("e:4:z:ditNP:p:D:E:w:h:H:",\%options);
# like the shell getopt, "d:" means d takes an argument
#print "Unprocessed by Getopt::Std:\n" if $ARGV[0];
#foreach (@ARGV) {
#  print "$_\n";
#}
#if (defined $options{d}) {
#	$debug = 1;
#}

doit($input);

exit(0);

#
# doit
# parse input file
# throw out extraneous bits and extract the good parts
#
sub doit() { 
	
	my $inputfile = $_[0];
	my $curline;
	my @words;
	my $ipaddr;
	my $port;

	#my $basename = File::Basename::basename($inputfile);
	#my @PARTS = split(/\./, $basename);

	open(FILE, $inputfile) || die "can't open $inputfile: $!\n";

	my $linecount = 0;
	while(<FILE>) {

		$linecount++;
		s/\n//g;
		s/ //g;
		s/\t//g;
		my $curline = $_;
		# note the escape needed
		@words = split(/\|/, $curline);
#if( $words[0] =~ /^#.*/){
#	print "true\n";
#}
#else {
#	print "false\n";
#}
		if ($linecount < 3) {
			next;
		}
		elsif( $words[0] =~ /^#.*/){
			next;
		}
                elsif( $words[0] =~ /<\/p.*/){
			next;
		}
#print "$words[0], $words[1], $words[2]\n";
#print "$words[0]\n";

		#$blah = $words[0];
		#$blah2 = $words[1];
		$ipaddr = $words[2];
		#$blah3 = $words[3];
		$port = $words[4];
# 		print "ipaddr $ipaddr $port\n";

		# TBD: also sanity check the ip address
		# currently insisting that port is a valid port number
		
		if (isnumber($port) && $port <= 65535 && $port >= 0) {
			iptoout($ipaddr, $port, $outputfile);
		}
		else {
			system("logger ccip.pl:attempt to past in non-number $port as port, ignored");
		}

		#dbmtest($ipaddr, $outputfile);

	}  # end loop
	close(FILE);
}

sub
iptoout
{
	my $ipaddr = $_[0];
	my $port = $_[1];

	print "$ipaddr $port\n"; 
}

sub
isnumber
{
	my $number = $_[0];
	return( ($number =~ /^\d+$/)?1:0 );

}

