#! /usr/bin/perl

#
# cciptodb.pl
#
# syntax:
#
#	cciptodb  inputfile  outputfile
#
#	inputfile - REN-ISAC list of cc IP addresses
#	outputfile - a perl DB suitable for IP address lookup

use Socket;
use Getopt::Std;
use File::Basename();

$input = "/home/mrourmon/etc/ipbm.txt";
$output = "/home/mrourmon/etc/cc";

#%options=();
#getopts("e:4:z:ditNP:p:D:E:w:h:H:",\%options);
# like the shell getopt, "d:" means d takes an argument
#print "Unprocessed by Getopt::Std:\n" if $ARGV[0];
#foreach (@ARGV) {
#  print "$_\n";
#}
#if (defined $options{d}) {
#	$debug = 1;
#}


doit($input, $output);

exit(0);

#
# doit
# parse input file
#
#	1. parse and store syn tuple - file to variables
#	2. compute work weight for this tuple.
#	3. filter netmask/workweight to leave tuples out if desired
#	4. compute a few global stats  
#	5. call writeSynReport to compute rs string  
#	6. write out long stats (stdout) per tuple stats string in non-summarized mode.
#
sub doit() { 
	
	my $inputfile = $_[0];
	my $outputfile = $_[1];
	my $curline;
	my @words;

	#my $basename = File::Basename::basename($inputfile);
	#my @PARTS = split(/\./, $basename);

	open(FILE, $inputfile) || die "can't open $inputfile: $!\n";

	my $linecount = 0;
	while(<FILE>) {

		$linecount++;
		s/\n//g;
		s/ //g;
		s/\t//g;
		my $curline = $_;
		# note the escape needed
		@words = split(/\|/, $curline);
#if( $words[0] =~ /^#.*/){
#	print "true\n";
#}
#else {
#	print "false\n";
#}
		if ($linecount < 3) {
			next;
		}
		elsif( $words[0] =~ /^#.*/){
			next;
		}
                elsif( $words[0] =~ /<\/p.*/){
			next;
		}
#print "$words[0], $words[1], $words[2]\n";
#print "$words[0]\n";

		$blah = $words[0];
		$blah2 = $words[1];
		$ipaddr = $words[2];
		$blah3 = $words[3];
# 		print "ipaddr $ipaddr\n";

		iptodb($ipaddr, $outputfile);
		#dbmtest($ipaddr, $outputfile);

	}  # end loop
	close(FILE);
}

# Ups - unique port sig
#
# print out port sigs that are unique
# on this sample pass.  We essentially
# boil the single ip instances down into classes
# as a result.  E.g., maybe you are seeing 10 different
# sasser worms or related things from 10 diff. ip srcs.
#
sub
iptodb
{
	my $ipaddr = $_[0];
	my $dbmfile = $_[1];
	my $key;
	my $value;


	dbmopen(%map, $dbmfile, 0666);
	# at this point key and value are the same, we need only
	# check for existance

	$key = $value = $ipaddr;
	# store in database
	$map{$key} = $value;	
	dbmclose(%map);
}


sub
dbmtest
{
	my $ipaddr = $_[0];
	my $dbmfile = $_[1];

	# for testing open the database and see if we get the key
	dbmopen(%map, $dbmfile, 0666);
	if ($map{$ipaddr}) {
		print "found it: $ipaddr\n";
	}
	if ($map{"1.1.1.1"}) {
		print "1.1.1.1: did not find it\n";
	}
	dbmclose(%map);
}
