#!/bin/sh
# getbots.sh - get evil lists from somewhere somehow
#	and process into useful internal forms for DNS/ourmon
# driven by crontab
#
#  e.g., bleedingsnort ???  (format is wrong)
#
# 1. get it
# 2. turn it into perl db with IP addresses for interested ourmon parties to use
# 3. push those files to ourmon probes and DNS systems (not done here, crontab)
#

# wget to get list of IP addresses from somewhere
# local output is ipbm.orig.txt - which is evil IP list in original form
/usr/local/bin/wget --output-document=/home/mrourmon/etc/ipbm.orig.txt --no-check-certificate 
https://SOMEWHERE/somefile --user=SOMEBODY --password=SOMEPASSWORD

# make minimum size check as we don't want a zero file
/home/mrourmon/bin/sizecheck.pl /home/mrourmon/etc/ipbm.orig.txt
SUCCESS=$?
# bail on this run if we can't get probe files for some reason
if [ $SUCCESS -ne 0 ]; then
	echo "getbots.sh - sizecheck.pl failed" 
	exit 1
fi

# wget fetch
# get remote list of DNS names if any
/usr/local/bin/wget --output-document=/home/mrourmon/etc/dns.orig.txt 
--no-check-certificate https://somewhere/somefile --user=SOMEUSER@SOMEWHERE.pdx.edu --password=SOMEPASSWORD

# make minimum size check
/home/mrourmon/bin/sizecheck.pl /home/mrourmon/etc/dns.orig.txt
SUCCESS=$?
# bail on this run if we can't get probe files for some reason
if [ $SUCCESS -ne 0 ]; then
	echo "getbots.sh - sizecheck.pl failed" 
	exit 1
fi

# process IP list ###########################################################

# fix this up to take inputs later, now hardwired
/home/mrourmon/bin/cciptodb.pl  

# make snort rules - /etc/snort/rules
#/home/mrourmon/bin/tracktosnort.sh

# make simple blacklist input file for ourmon
/home/mrourmon/bin/ccip.pl /home/mrourmon/etc/ipbm.orig.txt  > /home/devoid/blacklist.txt

# make dns file out of dns input
# note: two possible formats 
/home/mrourmon/bin/cctodns.pl > /home/devoid/malzone_file
/home/mrourmon/bin/cctodns.pl -z zone.evil > /home/devoid/evil.conf

# ourmon dns blacklist 
/home/mrourmon/bin/ccdns.pl > /home/devoid/ourmon_dns.txt

###################################################################################
# bleeding threats list (IPs only)
wget --output-document=/home/mrourmon/etc/bleeding.txt http://www.bleedingthreats.net/fwrules/bleeding-edge-Block-IPs.txt 
